class KctGuidepost < ActiveRecord::Base
  has_many :kct_signs, :class_name => KctKilometraz
  has_many :kct_trails, :through => :kct_signs

#  has_one :osm_guidepost, :through => :guidepost
#   has_one :guidepost, :foreign_key => :kctref, :primary_key=> :kctref
  def guidepost; Guidepost.find_by_kctref(kctref) end
  def osm_guidepost; guidepost.andand.osm_guidepost end
  
  def exists_by_kctref?; exists? end
  def exists?; !guidepost.nil? end
  def to_s(option=nil)
    case option
      when :long then "#{nazev} kčt:#{kctref}"
      else "kčt:#{kctref}" 
    end
  end

  def importable?; !osm_guidepost_by_kctref.nil? end
  def osm_guidepost_by_kctref; OsmGuidepost.find_by_kctref(kctref) end
  
  def coordinates_by_osm
    guidepost.andand.coordinates
  end
  
  def nazev_recased
    Unicode.capitalize(nazev)
  end

  def self.symbol; '&#10498;'.html_safe end
  def sign_on(kct_trail)
    KctKilometraz.find_by(kct_guidepost: self, kct_trail: kct_trail)
  end
  
  # Zda to vypadá jako dobré kctref rozcestníku
  def self.looks_like_kctref?(ref)
    ref =~ /^[A-Z][A-Z]\d\d\d$/
  end
  
  def kctrefs
    [self.kctref]
  end

end
